#ifndef __SINGLETON_H__
#define __SINGLETON_H__

#include <assert.h>

template <typename T> class CSingleton
{
	static T * ms_Singleton;

public:
	CSingleton()
	{
		assert(!ms_Singleton);
		int offset = (int)(T*)1 - (int)(CSingleton<T>*)(T*)1;
		ms_Singleton = (T*)((int)this + offset);
	}

	~CSingleton()
	{
		assert(ms_Singleton);
		ms_Singleton = 0;
	}

	static T& GetSingleton()
	{
		assert(ms_Singleton);
		return (*ms_Singleton);
	}

	static T* GetSingletonPtr()
	{
		return ms_Singleton;
	}
};

template <typename T> T * CSingleton <T>::ms_Singleton = 0;

#endif
